#### Chapter 2 Answers

# Challenge
# A Quiz App

#######################################################################################
# This is a challenge rather than an idea because by changing to a textbox a bug      #
# appears that needs fixing. We keep getting "There is no entry for this word." when  #
# it is run. One way to track down this error is to remove the try and except code to #
# see the error message. This gives us the message:                                   #
# KeyError: 'What does data-type mean?\n'                                             #
# This shows that by using END in get(0.0, END) we are collecting a line return as    #
# well as our expected text.                                                          #
#                                                                                     #
# Here are some ways to fix this:                                                     #
# 1. strip the /n off by using the rstrip() function                                  #
# 2. only select the first line of text: get(0.0, 1.75) – the lines are 75 chars long #
# 3. make the question variable global (this is the solution used here)               #
#######################################################################################

from tkinter import *
import random

question = ""

# key press function:
def click():
    output.delete(0.0, END)  # clear text box
    try:
        answer = my_flashcards[question]
    except:
        answer = "There is no entry for this word."
    output.insert(END, answer)

def click1():
    global question # declare question as global because it is changed by this function.
    questions = list(my_flashcards.keys()) # put all the keys into a list so that their indexes are numerical
    question = random.choice(questions) # choose a random question
    entry.delete(0.0, END)  # clear input text box
    output.delete(0.0, END)  # clear output text box
    entry.insert(END, question)

##### main:
window = Tk()
window.title("My Quiz App")

# Add a get question button:
b='GET Question'
Button(window, text=b, width=10, command=click1).grid(row=0,column=0, sticky=W)

# Add a get question button:
b='NEXT'
Button(window, text=b, width=10, command=click1).grid(row=0,column=1, sticky=E)

# create text entry box
entry = Text(window, width=75, height=1, wrap=WORD, background="light green")
entry.grid(row=1, column=0, columnspan=2, sticky=W)

# Add a submit button:
b='GET ANSWER'
Button(window, text=b, width=10, command=click).grid(row=3,column=0, sticky=W)

# create another label
Label(window, text="\nAnswer:").grid(row=5, column=0, sticky=W)

# create text box
output = Text(window, width=75, height=6, wrap=WORD, background="light green")
output.grid(row=6, column=0, columnspan=2, sticky=W)

# The dictionary:
my_flashcards = {
    'What is an argument?': 'A piece of information that is required by a function so that it can perform its task. Usually a string or number. my_function(arguments go here)',
    'What is a binary number?': 'A number represented in base 2.',
    'What is a bug?': 'A piece of code that is causing a program to fail to run properly or at all.',
    'What is casting?': 'The process of converting one data-type into another. For example, sometimes a number may stored as text but need to be converted in to an integer. This can be done like this, int("3")',
    'What is commenting?': 'Some text in a computer program that is for the human reader and is ignored by the computer when running the program. In python all comments begin with a hash symbol #',
    'What is a comparative operator?': 'Sometimes called logic operators, they allow us to compare data in a program. They include == and >',
    'What is a constant?': 'A number that does not change. It is good practice to name constants in capitals e.g. SPEED_OF_LIGHT',
    'What is a container?': 'Container data types store groups or other data types which may include more containers; the containers used in Python Next Steps are tuples, lists and dictionaries.',
    'What does data-type mean?': 'Different types of information stored by the computer, for example floats, integers and strings.',
    'What does debugging involve?': 'The process of finding bugs in a program.'
    }

##### Run mainloop
window.mainloop()
